%% make synthetic data set with errors as random permutation of residuals
newerrors = cumulativeresvec(randperm(length(cumulativeresvec)));
synthxpD = cell(1,nall);
for n=1:nall,
    synthxpD{n} = cell(1,AllTracks{n}.ntracks);
    for t=1:AllTracks{n}.ntracks,
        synthxpD{n}{t} = [];
        if inorexclude{n}(t),
%             filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
            npoints = length(fitfitD{n}{t});
            synthxpD{n}{t} = fitfitD{n}{t} + newerrors(1:npoints);%AllTracks{n}.shifts(filter,t);
            newerrors(1:npoints) = [];
        end;
    end;
end;

%% fit new best global slope

%     fitxpD = cell(1,nall);
    fitsymxpDprime = cell(1,nall); fitsynxpDbar = cell(1,nall);
    fitsynxpS = cell(1,nall);fitsynxpSprime = cell(1,nall); fitsynxpSbar = cell(1,nall);
    fitsynNt = cell(1,nall);
    fitsynbt = cell(1,nall);
    fitsynA = 0;
    fitsynfitD = cell(1,nall);
    for n=1:nall,
%         fitxpD{n} = cell(1,AllTracks{n}.ntracks);
        fitsymxpDprime{n} = cell(1,AllTracks{n}.ntracks);
        fitsynxpDbar{n} = cell(1,AllTracks{n}.ntracks);
        fitsynxpS{n} = cell(1,AllTracks{n}.ntracks);
        fitsynxpSprime{n} = cell(1,AllTracks{n}.ntracks);
        fitsynxpSbar{n} = cell(1,AllTracks{n}.ntracks);
        fitsynNt{n} = cell(1,AllTracks{n}.ntracks);
        fitsynbt{n} = cell(1,AllTracks{n}.ntracks);
        fitsynfitD{n} = cell(1,AllTracks{n}.ntracks);
        for t=1:AllTracks{n}.ntracks,
%             fitxpD{n}{t} = []; 
            fitsynxpS{n}{t} = []; fitsynNt{n}{t} = 0; fitsynbt{n}{t} = 0;
            fitsynfitD{n}{t} = [];
            if inorexclude{n}(t),
                filter = AllTracks{n}.slopes(:,t) > AllTracks{n}.slopefitmin(t);
                fitsynxpS{n}{t} = AllTracks{n}.slopes(filter,t);
%                 fitxpD{n}{t} = AllTracks{n}.shifts(filter,t);
                fitsynNt{n}{t} = length(fitsynxpS{n}{t});
                fitsynxpSbar{n}{t} = mean(fitsynxpS{n}{t});
%                 fitxpDbar{n}{t} = mean(fitxpD{n}{t});%replace
                fitsynxpDbar{n}{t} = mean(synthxpD{n}{t});
                fitsynxpSprime{n}{t} = fitsynxpS{n}{t}-fitsynxpSbar{n}{t};
%                 fitxpDprime{n}{t} = fitxpD{n}{t}-fitxpDbar{n}{t};%replace
                fitsymxpDprime{n}{t} = synthxpD{n}{t}-fitsynxpDbar{n}{t};
            end;
        end;
    end;
    sumDS = 0; sumSS = 0;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            if inorexclude{n}(t),
                sumDS = sumDS + sum(fitsymxpDprime{n}{t}.*fitsynxpSprime{n}{t});
                sumSS = sumSS + sum(fitsynxpSprime{n}{t}.*fitsynxpSprime{n}{t});
            end;
        end;
    end;
    fitsynA = sumDS/sumSS;
    for n=1:nall,
        for t=1:AllTracks{n}.ntracks,
            if inorexclude{n}(t),
                fitsynbt{n}{t} = fitsynxpDbar{n}{t} - fitsynA*fitsynxpSbar{n}{t};
                fitsynfitD{n}{t} = fitsynbt{n}{t} + fitsynA*fitsynxpS{n}{t};
            end;
        end;
    end;
